# stats.tcl
#	system statistics frame 


loadsource stats.common
set NUM 54

set ITEM(1) "Looking for data"
set ITEM(2) "empty event"
set ITEM(3) "Histogram increments"
set ITEM(4) "Buffers transmitted"
set ITEM(5) "Total data transmitted"
set ITEM(6) "Null events"
set ITEM(7) "fifo empty"

set ITEM(9) "SAC no event"

set ITEM(11) "Event not acceptable"
set ITEM(12) "Bad data"
set ITEM(13) "Events"

set ITEM(14) "Transfer error"
set ITEM(15) "Waiting for network"
set ITEM(16) "TDC no START item"
set ITEM(10) "SAC EvCnt read error"
set ITEM(17) "SAC multiple events"
set ITEM(18) "SAC not armed"
set ITEM(19) "SAC stopped"

set ITEM(41) "CAEN data items"
set ITEM(42) "CAEN fifo waiting"
set ITEM(43) "CAEN fifo abort"
set ITEM(44) "CAEN Bad data"
set ITEM(45) "CAEN fifo empty"
set ITEM(46) "CAEN events"
set ITEM(47) "CAEN fifo flush"
set ITEM(48) "CAEN data items flushed"
set ITEM(49) "CAEN TDC overflow"
set ITEM(50) "TDC multiple hits"
set ITEM(51) "CAEN ADC overflow"
set ITEM(52) "CAEN ADC underflow"



proc click-redisplay {} {
   global RDOUTserver NUM ITEM Stats Rates
   global EGreport

   set-footer "Updating..."
   set EGreport -1
   set-busy

   set StatsBlock [EG "register :name '/$RDOUTserver/NetVar.DACQ.Stats1' ?value"]
#   append StatsBlock [EG "register :name '/$RDOUTserver/NetVar.DACQ.Stats2' ?value"]

   set RatesBlock [EG "register :name '/$RDOUTserver/NetVar.DACQ.Rates1' ?value"]
#   append RatesBlock [EG "register :name '/$RDOUTserver/NetVar.DACQ.Rates1' ?value"]

   for {set i 0} {$i < $NUM} {incr i} {
       set Stats($i) [expr [lindex $StatsBlock [expr $i*2]]]
       if {[info exists ITEM($i)]} then {
	   :modify STAT$i :value $Stats($i)
       }
   }

   for {set i 0} {$i < $NUM} {incr i} {
       set Rates($i) [expr [lindex $RatesBlock [expr $i*2]]]
       if {[info exists ITEM($i)]} then {
           :modify RATE$i :value $Rates($i)
       }
   }

   custom_redisplay

   clear-busy
   set EGreport 0
   set-footer "Counts Updated [date]"
}

proc read-Rate {n} {global Rates; return $Rates($n)}
