


global StatusAddress DataAddress ArmAddress TraceAddress QuixTraceLength
set StatusAddress 0
set ArmAddress 6
set DataAddress 512
set TraceAddress 8192
set QuixTraceLength 512


proc MyLog {s} {
    global MIDAS_QServer_Verbose 
    if {$MIDAS_QServer_Verbose} {puts stdout "$s\n"}
}

proc QServer_Init {} {

    MyLog "QServer_Init: Configured"

    return 0
}

proc QServer_Exit {} {

   return 0

}


proc QServer_Read {Address Count} {

#    data is A16 D32:    Count is the number of D32 data items

    set length [expr $Count * 2]     ;# number of 16 bit integers - must be a multiple of 2 between 2 and 16K
    set address $Address             ;# base address - must be a multiple of 2 between 2 and 16K

#    read server block

    set response [expr $length * 2]

    set data {}; for {set i 0} {$i < [llength $response]} {} {
        incr i 4
        append data [format "  0x%08x"  0x0102]
    }

MyLog "Finished OK"

   return $data
}


proc QServer_Write {Address Count Data} {

MyLog "Finished OK"

   return 0
}


proc QServer_GetEvent {NumChans TraceLength} {
    global StatusAddress DataAddress ArmAddress
    global TraceAddress QuixTraceLength

    set status [QServer_Read $StatusAddress 1]

    if {[expr $status & 2] != 2} {return 0xffffffff}

    if {$NumChans == 0} then {set eventdata ""} else {set eventdata [QServer_Read $DataAddress $NumChans]}

    if {$TraceLength == 0} then {set tracedata ""} else {set tracedata [QServer_Read $TraceAddress $TraceLength]}

    set rc [QServer_Write $ArmAddress 1 0x1]

    return "$eventdata $tracedata"
}
