/* ... "ebhsm.h" ...  HSM specific definitions ... */

#define HSMBUFFERS           32

#define HSMBUFFERSINUSE      32

#define HSMTRANSITBUFFERS    (HSMBUFFERS+1)

#define HSMBYTESPERBUFFER    0x4000


/* Freeq length must be greater than number of hsm buffers */

#define FREEQ_LENGTH            (HSMBUFFERSINUSE+1)
#define ENQ_LENGTH              (HSMBUFFERSINUSE+1)

#define HSM_INTERRUPT_REG      0x00000400  /* level 4 */
#define HSM_INTERRUPT_CLEAR    0x00000800
#define HSM_CONTROL_REG        0x00002000  /* ovflow=512,no interrupts */
#define HSM_DISABLE_INTS       0x00000000  /* stop,memfull,fifo interrupts */
#define HSM_ENABLE_ACQ         0x00001000  /* enable acq */
#define HSM_DISABLE_ACQ        0x00000000  /* disable acq */

#define HSM_REG_OFFSET         0x00100000

#ifdef OLDHSM
#define HSM_ENABLE_INTS        0x00000d00  /* stop,memfull,fifo interrupts */

#define HSM_VME_BASE           0x0f000000
#define HSM_VSB_BASE           0x00000000   /* !!!! */
#else
#define HSM_ENABLE_INTS        0x00000700  /* ovflow,memfull,fifo ints */

#define HSM_VME_BASE           0x0f000000
#define HSM_VSB_BASE           0x00000000   /* !!!! */
#endif


/* ======================================================================== */



