/* Include file "mtsort-unix.h" for Unix uni-processor version of MTsort */

#define PROCTYPE UNI
#define MAXOUTSTREAMS 1

#define forward extern

#define TRUE 1
#define FALSE 0

extern int current_stream;

extern int **simples;            /* defined 16384+2048 in local-version.h */
extern int **simples_addr;

extern int **groups;                   /* defined 256 in local-version.h */
extern int **groups_addr;

extern int simples_found[];

extern int groups_found[];

extern int *triggers[];           /* only used by non-eurogam event formats */
extern int trigger_length[];      /* only used by non-eurogam event formats */

extern int *eventptr,*eventstart,*eventend;
extern void *localdata;

extern struct statistics_record *stats;

#include <mtsortstats.h>

extern int *outptr1,*outptr2,*outptr3,*outptr4;
extern int *outhwm1,*outhwm2,*outhwm3,*outhwm4;

extern int *blocks_input;
extern int *blocks_output;
extern int *events_input;
extern int *events_output;

extern int pass_through;          /* 1=Event blocks not sorted but go to output */

/* In each of these spectrum access routines, type of "S" is set by compiler */

#define incbyte(S,X)     S[X]++

#define incword(S,X)     S[X]++

#define inclong(S,X)     S[X]++

#define decbyte(S,X)     S[X]--

#define decword(S,X)     S[X]--

#define declong(S,X)     S[X]--

#define setbyte(S,X,Y)   S[X]=Y

#define setword(S,X,Y)   S[X]=Y

#define setlong(S,X,Y)   S[X]=Y

#define getbyte(S,X)     S[X]

#define getword(S,X)     S[X]

#define getlong(S,X)     S[X]


#ifndef __DEC
float MT_random();
#endif

double sqrt(double);
double exp(double);
double log(double);
double log10(double);
double sin(double);
double cos(double);
double tan(double);
double asin(double);
double acos(double);
double atan(double);
double pow(double,double);

