


variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable Present 
    variable CorePresent
    variable SegmentPresent 
    variable FpgaList
    variable FpgaIDs 
    variable Fpga 
    variable ShortTimeOut 5000

    variable Digitizer      -1
    variable NumDigitizer    0
    variable DigitizerList   {}

    variable Address         0x0000
    variable Data            0x0000
    variable DataBlock       0x0000
    variable Length          1
    variable AddressModifier A16

    variable SyncCounter 0
    variable SyncPeriod 0

    variable Offset

    for {set i 1} {$i <= 7} {incr i} {set Offset($i) 0}

    set FpgaList {"Use Probe Hardware"}
    set FpgaIDs {}       ;# 0 1 2 3 8 9 10 11 12
    set Fpga "Use Probe Hardware"

#   access procedures

    set CorePresent 0        ;#   for current digitizer
    set SegmentPresent 0     ;#   for current digitizer
    for {set i 0} {$i <= 12} {incr i} {set Present($i) 0}     ;# index is fpga ID

   source Global.tcl
#   source Common.tcl

   proc  show_variables {} {
        variable Address
        variable Data
        variable Length
        variable AddressModifier

        variable ShowLogFlag
        variable JS

        variable  Digitizer 
        variable  Fpga 
        variable  FpgaList 
        variable  FpgaIDs 

         if {$ShowLogFlag == 1} {
             EmptyLog
             InsertLog "Address=$Address; Data=$Data; Length=$Length; AddressModifier=$AddressModifier; Digitizer=$Digitizer; Fpga=$Fpga"
         }  else {
             append JS "alert(\"Address=$Address; Data=$Data; Length=$Length; AddressModifier=$AddressModifier; Digitizer=$Digitizer; Fpga=$Fpga\");"
         }
   }

    proc do_parameters {} {
        variable cgidata
        variable Digitizer
        variable Address
        variable Data
        variable Length
        variable AddressModifier
        variable Fpga
        variable DataBlock
        variable SyncPeriod

        for {set i 2} {$i < [llength $cgidata]} {incr i} {

            set name [lindex $cgidata $i]
            incr i
            set value [lindex $cgidata $i]

            switch -glob $name {

               AddressModifier -
               Fpga -
               Digitizer  -
               Address  -
               Length -
               DataBlock -
               SyncPeriod -
               Data  {
                    variable $name
                    set $name $value
                   InsertLog "$name = $value"
               }
            }
        }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {
            do_parameters
            switch -glob [lindex $cgidata 1] {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                PROBE    {
                    for {set i 2} {$i < [llength $cgidata]} {incr i} {
                       set name [lindex $cgidata $i]
                       incr i
                       set value [lindex $cgidata $i]
                       switch $name {
                          Digitizer  {set $name $value}
                          default    {}
                       }
                    }
                    click-probe
                }

                SET      {do_set}
                GET      {do_get}
                READ     {do_read}
                WRITE    {do_write}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

}   ;# end of if {$started == 0} 

